SalvAway = {}

SLASH_SALVAWAY1 = "/salvaway"

local _G = _G;

local CColourDefaultMessage = "00FFFF00"
local CColourRemoveMessage = "00FF3300"
local CSpellBlessingOfSalvationID = 1038
local CSpellGreaterBlessingOfSalvationID = 25895
local CSpellBlessingOfSalvationLocalisedName = GetSpellInfo(CSpellBlessingOfSalvationID)
local CSpellGreaterBlessingOfSalvationLocalisedName = GetSpellInfo(CSpellGreaterBlessingOfSalvationID)

local Options = {}
local SalvDetected = 5

local SalvAway_EventFrame = CreateFrame("FRAME")

------------------------------------------------------------------------------------
-- Main form functionality ---------------------------------------------------------
------------------------------------------------------------------------------------

function SalvAway_OnSecond()

	-- Attempt to delete Salv for 5 seconds after receiving detection of it
	if SalvDetected > 0 then
		SalvAway:RemoveSalv()
		SalvDetected = SalvDetected - 1
	end

end

------------------------------------------------------------------------------------

local function SalvAway_EventHandler(Self, Event, ...)

	if Event == "UNIT_AURA" then
		if not Options.KeepSalv then
			SalvDetected = 5
			SalvAway:RemoveSalv()
		end
	elseif Event == "PLAYER_LOGIN" then
		-- Load from our global variables
		Options = SalvAway_Options

		if Options == nil then
			Options = {}
			Options.KeepSalv = true
		end	
		
		if Options.KeepSalv then
			DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "Salv Away (Classic) - Loaded|r")		
			DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "Salv will be kept. Type '/salvaway' for options.|r")		
		else
			DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "Salv Away (Classic) - Loaded|r")		
			DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "Salv will be removed. Type '/salvaway' for options.|r")
		end	
	elseif Event == "PLAYER_LOGOUT" then
		-- Save back to our global variables
		SalvAway_Options = Options
	end

end

------------------------------------------------------------------------------------

function SalvAway:RemoveSalv()

	if SalvDetected == 0 then
		return
	end
	
	if Options.KeepSalv then
		return
	end

	local BuffIndex, SpellID = 0, 0
	local BuffName = ""

	for i = 1,40 do
		BuffName = UnitAura("player", i)
		
		if ( BuffName == CSpellGreaterBlessingOfSalvationLocalisedName ) or ( BuffName == CSpellBlessingOfSalvationLocalisedName ) then
			BuffIndex = i
			break
		end
	end
	
	if BuffIndex ~= 0 then
		if UnitAffectingCombat("player") then
			SalvDetected = 5
			DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourRemoveMessage .. "[SalvAway]: Cannot remove Salv (in combat). Please remove manually.|r")		
		else	
			CancelUnitBuff("player", BuffIndex)
			DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourRemoveMessage .. "[SalvAway]: Salv has been removed!|r")		
		end
	end	
	
end

------------------------------------------------------------------------------------

function SalvAway:ShowCommandLineUsage()

	DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "[SalvAway]: Usage:|r")
	DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "     /salvaway away|r")
	DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "     /salvaway keep|r")
	
end

------------------------------------------------------------------------------------

function SlashCmdList.SALVAWAY(AMsg, AEditBox)

	-- Known command-line parameters
	--   away
	--   keep
	
	AMsg = string.lower(AMsg)
	
	if AMsg == "away" then
		Options.KeepSalv = false
		DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "[SalvAway]: Salv will be removed|r")
		SalvDetected = 5
	elseif AMsg == "keep" then
		Options.KeepSalv = true
		DEFAULT_CHAT_FRAME:AddMessage("|c" .. CColourDefaultMessage .. "[SalvAway]: Salv will be kept|r")
	else
		SalvAway:ShowCommandLineUsage()
	end

end	

------------------------------------------------------------------------------------

SalvAway_EventFrame:RegisterEvent("PLAYER_LOGIN")
SalvAway_EventFrame:RegisterEvent("PLAYER_LOGOUT")
SalvAway_EventFrame:RegisterUnitEvent("UNIT_AURA", "player")
SalvAway_EventFrame:SetScript("OnEvent", SalvAway_EventHandler)

C_Timer.NewTicker(1, SalvAway_OnSecond)

